; CHAR.ASM
; part of Ben's Command Extender
; character handling routines mostly filters
; 5 Dec 97
; 12 Dec 97 added NOCHR
; blm
;

; lcase
; filter input changing uppercase to lowercase
lcase:
	push    ax

.next_char:
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	cmp     al, 'Z'
	ja      .lower_case
	cmp     al, 'A'
	jb      .lower_case
	add     al, 20h
.lower_case:
	call    putc
	jmp     .next_char
.done:  
	pop     ax
	ret
	
	

; ucase
; filter input changing lowercase to uppercase
ucase:

.next_char:
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	cmp     al, 'z'
	ja      .upper_case
	cmp     al, 'a'
	jb      .upper_case
	sub     al, 20h
.upper_case:    
	call    putc
	jmp     .next_char
.done:  
	
	xor		ax, ax
	ret
	
	
	
; noctr
; filter input removing control characters
noctr:
	
.next_char: 
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	cmp     al, 20h
	jb      .next_char
	call    putc
	jmp     .next_char
	
.done:
	xor		ax, ax
	ret
	
	
	
; nochr
; filter input removing ASCII %1 characters
nochr:
		
   	mov 	ax, string
	call	nextarg		; skip arg0
	call	nextarg
	call	strlen
	and		ax, ax
	jz		.error
	mov		ax, string
	call	atou
	
	mov		byte [cs:filt_char], al
.next_char: 
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	cmp     al, [cs:filt_char]
	je      .next_char
	call    putc
	jmp     .next_char
	
.error:
	mov		ax, 01h

.done:  
	ret	
	
	
; noext
; filter input removing extended characters
noext:
	
.next_char: 
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	test    al, 80h
	jne     .next_char
	call    putc
	jmp     .next_char
	
.done:
	xor		ax, ax
	ret
	
	
	
; xpand
; filter input expanding tabs into spaces
xpand:
	mov		ax, string
	call    nextarg         ; skip arg0
	mov		ax, string
	call    nextarg
	mov		ax, string
	call    atou
	and     ax, ax
	jz      .next_char
	mov     [cs:xpand_count], ax
	
.next_char: 
	mov     ah,0Bh
	int     21h
	and     al, al
	jz      .done
	mov     ah, 07h
	int     21h
	cmp     al, TAB
	jne     .not_tab
	mov     cx, [cs:xpand_count]
.next_space
	mov     al, 20h
	call    putc
	loop    .next_space
	jmp     .next_char
	
.not_tab
	call    putc
	jmp     .next_char
	
.done:
	xor		ax, ax
	ret
	

; char data
xpand_count     dw 0004h
filt_char		db 0000h
