; FILdE.ASM
; part of Ben's Command Extender
; file handling procs
; 5 Dec 97
; 8 Dec 97  completely resturctured
; 9 Dec 97 added set_fdate and set_ftime
; 11 Dec 97 fixed fdate routines
; blm
;

; fdate
; get date of file arg1
fdate:
	
	mov		ax, string
	call    nextarg     ; skip arg0
	mov		ax, string
	call    nextarg
	mov		ax, string
	call    strlen
	and     ax, ax
	jz     .bail_out

	call	open
	and		ax, ax
	jz		.bail_out
	mov     word [cs:handle], ax
	
	mov		ax, string
	call	nextarg
	mov		ax, string
	call	strlen
	and		ax, ax
	jz		.check_only
	mov		dx, string
	mov		ax, [cs:handle]
	call	set_fdate
	and		ax, ax
	jz		.bail_close
	
.check_only:
	mov		ax, [cs:handle]
	call	get_fdate
	and		ax, ax
	jz		.bail_close
	call	put_fdate

.done:
	mov		ax, [cs:handle]
	call	close
	xor		ax, ax
	ret

.bail_close:
	mov     ax, [cs:handle]
	call	close
.bail_out:	
	mov		ax, 01h
	ret
	
	
	
; ftime
; get time of file arg1
ftime:
	
	mov		ax, string
	call    nextarg     ; skip arg0
	mov		ax, string
	call    nextarg
	mov		ax, string
	call    strlen
	and     ax, ax
	jz      .bail_out
	
	call	open
	and		ax, ax
	jz		.bail_out
	mov     word [cs:handle], ax
	
	mov		ax, string
	call	nextarg
	mov		ax, string
	call	strlen
	and		ax, ax
	jz		.check_only
	mov		dx, string
	mov		ax, [cs:handle]
	call	set_ftime
	and		ax, ax
	jz		.bail_close
	
.check_only:
	mov		ax, [cs:handle]
	call	get_ftime
	and		ax, ax
	jz		.bail_close
	call	put_ftime
	
.done:
	mov     ax, [cs:handle]
	call	close
	xor		ax, ax
	ret
	
.bail_close:
	mov		ax, [cs:handle]
	call	close
.bail_out:
	mov		ax, 01h
	ret
	
	
	
; open
; open the file whose name is in string
; returns handle in ax
open:
	push	dx
	push    ds
	
	push    cs
	pop     ds
	
	mov     dx, string
	mov     ax, 3D00h
	int     21h
	jnc     .no_error
	xor		ax, ax
.no_error:

	pop		ds
	pop		dx
	ret
	
	
	
; close
; close file whose handle is in ax
; if carry flag is set on return check ax for error
close:
	push	bx
	
	mov		bx, ax
	mov     ah, 3Eh
	int     21h
	
	pop		bx
	ret
	
	
	
; get_fdate
; returns date of file whose handle is ax
get_fdate:
	push	bx
	push	cx
	push	dx
	
	mov		bx, ax
	mov		ax, 5700h
	int		21h
	jnc		.no_error
	xor		dx, dx

.no_error:
	mov		ax, dx
	
	pop		dx
	pop		cx
	pop		bx
	ret
	
	
	
; set_fdate
; sets the date of file whose handle is ax to date in string dx
; date string MUST be in the format MM-DD-YY
set_fdate:
	push	bx
	push	cx
	push	dx

	mov		bx, ax

	mov		ax, dx
	call	strlen
	cmp		ax, 8
	jb		.error

	mov		word [cs:date_value], 0000h
; get month
	mov		ax, dx
	mov		dx, dt_string
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	shl     ax, 5
	or		word [cs:date_value], ax

; get day
	mov		dx, dt_string
	mov		ax, string+3
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	or		word [cs:date_value], ax
	
; get year	
	mov		dx, dt_string
	mov		ax, string+6
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	cmp		ax, 79
	jg		.nineteen
	add		ax, 20
	jmp		.twenty
.nineteen:
	sub		ax, 80
.twenty:	
	shl		ax, 9
	or		word [cs:date_value], ax
	mov		ax, bx
	call	get_ftime
	mov		cx, ax
	mov		dx, [cs:date_value]
	mov		ax, 5701h
	int		21h
	jc		.error
	mov		ax, [cs:date_value]
	jmp		.done
	
.error:
	xor		ax, ax

.done:
	pop		dx
	pop		cx
	pop		bx
	ret
	
	
; put_fdate
; prints value in ax as MM-DD-YY
; Bitfields for file date:
;Bit(s) Description (Table 0972)
; 15-9  year - 1980
; 8-5   month
; 4-0   day
put_fdate:
	push	ax
	mov		word [cs:date_value], ax

; print month
	shr     ax, 5
	and     ax, 0Fh
	cmp     ax, 10
	jge     .no_pad_mon
	push	ax
	mov		al, '0'
	call	putc
	pop		ax
.no_pad_mon:
	call    putd
	mov     al, '-'
	call	putc

; print day
	mov     ax, [cs:date_value]
	and     ax, 1Fh
	cmp     ax, 10
	jge     .no_pad_day
	push	ax
	mov		al, '0'
	call	putc
	pop		ax
.no_pad_day:    
	call    putd
	mov     al, '-'
	call	putc

; print year
	mov     ax, [cs:date_value]
	shr     ax, 9
	and     ax, 7Fh
	cmp     ax, 19
	jg      .twenty
	add		ax, 80
	jmp		.nineteen
.twenty:
	sub		ax, 20
.nineteen:
	cmp     ax, 10
	jge     .no_pad_year
	push	ax
	mov		al, '0'
	call	putc
	pop		ax	
.no_pad_year:
	call    putd
	call    [cs:new_line]
	
	pop		ax
	ret
	
	
	
; get_ftime
; returns time of file whose handle is ax
get_ftime:
	push	bx
	push	cx
	push	dx
	
	mov		bx, ax
	mov		ax, 5700h
	int		21h
	jnc		.no_error
	xor		cx, cx
	
.no_error:	
	mov		ax, cx
	
	pop		dx
	pop		cx
	pop		bx
	ret
	
	
	
; set_ftime
; sets the time of file whose handle is ax to time in string dx
; date string MUST be in the format HH:MM:SS
set_ftime:
	push	bx
	push	cx
	push	dx

	mov		bx, ax

	mov		ax, dx
	call	strlen
	cmp		ax, 8
	jb		.error

	mov		word [cs:time_value], 0000h
; get hour
	mov		ax, dx
	mov		dx, dt_string
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	shl     ax, 11
	or		word [cs:time_value], ax

; get minute
	mov		dx, dt_string
	mov		ax, string+3
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	shl		ax, 5
	or		word [cs:time_value], ax
	
; get second
	mov		dx, dt_string
	mov		ax, string+6
	mov		cx, 2
	call	strncpy
	mov		ax, dt_string
	call	atou
	shr		ax, 1
	or		word [cs:time_value], ax

   	mov		ax, bx
	call	get_fdate
	mov		dx, ax
	mov		cx, [cs:time_value]
	mov		ax, 5701h
	int		21h
	jc		.error
	mov		ax, [cs:time_value]
	jmp		.done
	
.error:
	xor		ax, ax

.done:
	pop		dx
	pop		cx
	pop		bx
	ret



; put_ftime
; prints value in ax as HH:MM:SS
;Bitfields for file time:
;Bit(s) Description (Table 0971)
; 15-11 hours (0-23)
; 10-5  minutes
; 4-0   seconds/2
put_ftime:
	push	ax
	mov		word [cs:time_value], ax
	
; print hour
	shr     ax, 11
	and     ax, 1Fh
	cmp     ax, 10
	jge     .no_pad_hour
	push	ax
	mov		al, '0'
	call	putc
	pop		ax
.no_pad_hour:   
	call    putd
	mov     al, ':'
	call	putc

; print minute
	mov     ax, [cs:time_value]
	shr     ax, 5
	and     ax, 3Fh
	cmp     ax, 10
	jge     .no_pad_min
	push	ax
	mov		al, '0'
	call	putc
	pop		ax
.no_pad_min
	call    putd
	mov     al, ':'
	call	putc

; print second
	mov     ax, [cs:time_value]
	and     ax, 1Fh
	shl     ax, 1
	cmp     ax, 10
	jge     .no_pad_sec
	push	ax
	mov		al, '0'
	call	putc
	pop		ax
.no_pad_sec:    
	call    putd
	call    [cs:new_line]
	
	pop		ax
	ret
	
	
	
; file data
date_value      dw 0000h
time_value      dw 0000h
handle          dw 0000h
dt_string		times 16 db 00h

